<!DOCTYPE html>
<html>
<head>
	<title>Mon Simon</title>


	<style type="text/css">
		button {
			width: 100px;
			height: 100px;
			display: inline-block;
			padding: 0;
			background-color: #fff;
		}
		span.pushed {
			background-color: #de5214;
			display: none;
			width: 100%;
			height: 100%;
		}
		button#btn2 span.pushed {
			background-color: #52de14;
		}
		button#btn3 span.pushed {
			background-color: #5214de;
		}
		button#btn4 span.pushed {
			background-color: #dede52;
		}
		button:active span.pushed, button.actif span.pushed {
			display: block;
		}
	</style>
</head>
<body>
	<button id="btn1"><span class="pushed"></span></button>
	<button id="btn2"><span class="pushed"></span></button>
	<button id="btn3"><span class="pushed"></span></button>
	<button id="btn4"><span class="pushed"></span></button>

	<script type="text/javascript">

		<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous">


		var boutons = [document.getElementById("btn1"), document.getElementById("btn2"), document.getElementById("btn3"), document.getElementById("btn4")];
		var sequence = [];

		// 0 : initialisation
		for (var i = 0; i < 4; i++) {
			sequence.push(boutons[Math.floor(Math.random() * 4)]);
		}
		
		console.log("Memorisez la sequence");
		// 1 : montrer au joueur les boutons choisis
		var courant = 0;
		function allumer() {

			function eteindre(bouton_a_eteindre) {
				bouton_a_eteindre.classList.remove('actif');
			}

			// allumer le bouton
			sequence[courant].classList.add('actif');

			// différer l'extinction de 600ms
			setTimeout(eteindre, 600, sequence[courant]);

			// différer l'allumage du bouton suivant dans 700ms
			courant++;
			if (courant < sequence.length) {
				setTimeout(allumer, 700);
			} else {
				// quand la séquence est finie, on laisse le joueur jouer
				tourJoueur();
			}
		}


		function tourJoueur() {
			console.log("A vous !");
			courant = 0;

			// au bout de cinq secondes, gameover
			var to = setTimeout(gameover, 5000);

			// écoutons les clics
			for (var i = 0; i < boutons.length; i++) {
				boutons[i].addEventListener("click", verif);
			}

			function gameover() {
				// ne pas oublier de retirer les écouteurs de clic
				console.log('Temps écoulé');
				for (var i = 0; i < boutons.length; i++) {
					boutons[i].removeEventListener("click", verif);
				}
			}

			// comparer avec la séquence
			function verif() {
				// dans tous les cas, on retire le timeout qui lance le gameover à 5s
				clearTimeout(to);
				// this désigne le bouton cliqué
				if (this != sequence[courant]) {
					// perdu
					sequence = [];
					courant = 0;
					console.log("Perdu !");
					// on retire les listeners
					for (var i = 0; i < boutons.length; i++) {
						boutons[i].removeEventListener("click", verif);
					}
				} else {
					// bon bouton
					courant++;
					if (courant < sequence.length) {
						// s'il reste des boutons à cliquer, c'est tout ce qu'il y a à faire, les boutons continuent d'écouter, le tour du joueur continue
						to = setTimeout(gameover, 5000);
					} else {
						// round gagné
						// on ajoute un bouton à la séquence
						sequence.push(boutons[Math.floor(Math.random() * 4)]);
						courant = 0;
						setTimeout(allumer, 300);
						// on retire les listeners, c'est à l'ordinateur de montrer la séquence
						for (var i = 0; i < boutons.length; i++) {
							boutons[i].removeEventListener("click", verif);
						}
					}
				}
			}
		}

		allumer();
	</script>
</body>
</html>